<?php
/**
 * @package   AkeebaLoginGuard
 * @copyright Copyright (c)2016-2022 Nicholas K. Dionysopoulos / Akeeba Ltd
 * @license   GNU General Public License version 3, or later
 */

defined('_JEXEC') || die;

use Akeeba\Component\LoginGuard\Administrator\Extension\LoginGuardComponent;
use Akeeba\Component\LoginGuard\Administrator\Provider\RouterFactory;
use Joomla\CMS\Component\Router\RouterFactoryInterface;
use Joomla\CMS\Dispatcher\ComponentDispatcherFactoryInterface;
use Joomla\CMS\Extension\ComponentInterface;
use Joomla\CMS\Extension\Service\Provider\ComponentDispatcherFactory;
use Joomla\CMS\Extension\Service\Provider\MVCFactory;
use Joomla\CMS\HTML\Registry;
use Joomla\CMS\MVC\Factory\MVCFactoryInterface;
use Joomla\DI\Container;
use Joomla\DI\ServiceProviderInterface;

return new class implements ServiceProviderInterface {
	/**
	 * Registers the service provider with a DI container.
	 *
	 * @param   Container   $container   The DI container.
	 *
	 * @return  void
	 * @since   6.0.0
	 */
	public function register(Container $container)
	{
		// Get Joomla services
		$container->registerServiceProvider(new MVCFactory('Akeeba\\Component\\LoginGuard'));
		$container->registerServiceProvider(new ComponentDispatcherFactory('Akeeba\\Component\\LoginGuard'));
		$container->registerServiceProvider(new RouterFactory('\\Akeeba\\Component\\LoginGuard'));

		$container->set(
			ComponentInterface::class,
			function (Container $container) {
				$component = new LoginGuardComponent($container->get(ComponentDispatcherFactoryInterface::class));

				$component->setRegistry($container->get(Registry::class));
				$component->setMVCFactory($container->get(MVCFactoryInterface::class));
				$component->setRouterFactory($container->get(RouterFactoryInterface::class));

				return $component;
			}
		);
	}
};
